--#include "Prelude.agda"


Unop ::(X::Set) ->  Set
Unop X = X -> X

Binop :: (X::Set) ->  Set
Binop  X  = X -> X -> X

Ass(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> Set
Ass (==) (&) = (x1,x2,x3::X) -> x1 & x2 & x3 == x1 & (x2 & x3)

Com(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> Set
Com (==) (&) = (x1,x2::X) -> x1 & x2 == x2 & x1

Idem(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> Set
Idem (==) (&) = (x::X) -> x & x == x

ComOpLft(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> Set
ComOpLft (==) (&) = (x,y,z::X) -> x & (y & z) == y & (x & z)

ComOpRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> Set
ComOpRgt (==) (&) = (x,y,z::X) -> x & y & z == x & z & y

IdLft(X::Set) :: ((==)::X -> X -> Set) ->  ((*)::Binop X) -> (unit::X) -> Set
IdLft (==) (*) unit = (x::X) -> unit * x == x

IdRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((*)::Binop X) -> (unit::X) -> Set
IdRgt (==) (*) unit = (x::X) -> x * unit == x

CancelEqnLft(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> Set
CancelEqnLft (==) (&) = (x1,x2,x3::X) -> x1 & x2 == x1 & x3 -> x2 == x3

CancelEqnRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> Set
CancelEqnRgt (==) (&) = (x1,x2,x3::X) -> x1 & x3 == x2 & x3 -> x1 == x2


-- Note the order of the operator arguments to the distributive laws.
DistrLft(X::Set) :: ((==)::X -> X -> Set) ->  ((*),(+)::Binop X) -> Set
DistrLft (==) (*) (+) = (x1,x2,x3::X) ->
                     x1 * (x2 + x3) == x1 * x2 + x1 * x3

DistrRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((*),(+)::Binop X) -> Set
DistrRgt (==) (*) (+) = (x1,x2,x3::X) ->
                   (x1 + x2) * x3 == x1 * x3 + x2 * x3

HomZerop(X::Set) :: ((==)::X -> X -> Set) ->  (f::Unop X) -> (a,b::X) -> Set
HomZerop (==) f a b = f a == b

HomUnop(X::Set) :: ((==)::X -> X -> Set) ->  (f,g,h::Unop X) -> Set
HomUnop (==) f g h = (x::X) -> f (g x) == h (f x)

HomBinop (X::Set) :: ((==)::X -> X -> Set) ->  (f::Unop X) -> ((+),(*)::Binop X) -> Set
HomBinop (==) f (+) (*) = (x,y::X) -> f (x + y) == f x * f y

HomZeropLft(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> (a,b::X) -> Set
HomZeropLft (==) (&) a b = (x::X) -> x & a == b

HomZeropRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> (a,b::X) -> Set
HomZeropRgt (==) (&) a b = (x::X) -> a & x == b

HomUnopLft(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> (f,g::Unop X) -> Set
HomUnopLft (==) (&) f g = (x,y::X) -> x & (f y) == g (x & y)

HomUnopRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((&)::Binop X) -> (f,g::Unop X) -> Set
HomUnopRgt (==) (&) f g = (x,y::X) -> f x & y == g (x & y)

HomBinopLft(X::Set) :: ((==)::X -> X -> Set) ->  ((^),(+),(*)::Binop X) -> Set
HomBinopLft (==) (^) (+) (*) = (x,y,z::X) -> x ^ (y + z) == x ^ y * x ^ z

HomBinopRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((^),(+),(*)::Binop X) -> Set
HomBinopRgt (==) (^) (+) (*) = (x,y,z::X) -> (x + y) ^ z == x ^ z * y ^ z

CnstLft(X::Set) :: ((==)::X -> X -> Set) ->  ((*)::Binop X) -> (zero::X) -> Set
CnstLft (==) (*) zero = (x::X) -> zero * x == zero

CnstRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((*)::Binop X) -> (zero::X) -> Set
CnstRgt (==) (*) zero = (x::X) -> x * zero == zero

InvLft(X::Set) :: ((==)::X -> X -> Set) ->  ((*)::Binop X) -> (unit::X) -> (inv::Unop X) -> Set
InvLft (==) (*) unit inv = (x::X) -> inv x * x == unit

InvRgt(X::Set) :: ((==)::X -> X -> Set) ->  ((*)::Binop X) -> (unit::X) -> (inv::Unop X) -> Set
InvRgt (==) (*) unit inv = (x::X) -> x * inv x == unit

LftInvUnop(X::Set) :: ((==)::X -> X -> Set) ->  (f,g::Unop X) -> Set
LftInvUnop (==) f g = (x::X) -> f (g x) == x
