--#include "Prelude.agda"
--#include "Unit.agda"
-- data Bool = False | True 
-- is pre-defined

elimBool :: (C :: Bool -> Type) ->
            (c_t :: C True) ->
            (c_f :: C False) ->
            (b :: Bool) -> 
            C b 
elimBool C c_t c_f b = case b of 
                           (False) -> c_f
                           (True) -> c_t


dep_if (A,B::Set)
   :: (h::Bool) -> A -> B -> if h then A else B
dep_if h a b = elimBool (\h -> if h then A else B) a b h



liftBool :: Bool -> Set
liftBool b = if b then Unit else Empty

not :: Bool -> Bool
not b = if b then False else True


(&&) :: Bool -> Bool -> Bool 
b1 && b2 = if b1 then b2 else False

(||) :: Bool -> Bool -> Bool 
b1 || b2 = if b1 then True else b2

imp ::  (x,y::Bool) -> Bool
imp x y = (not x) || y

iff ::  (x,y::Bool) -> Bool
iff x y = x `imp` y && y `imp` x

pred :: (X::Set) -> Set
pred X = X -> Bool

rel :: (X::Set) -> Set
rel X = X -> X -> Bool

collapsedLiftBool :: (b::Bool) -> Collapsed (liftBool b)
collapsedLiftBool b = case b of 
                        (False) -> \(P::Empty -> Set) -> \(x1,x2::Empty) |-> \(h::P x1) -> elimEmpty (\(x1'::Empty) -> P x2) x1
                        (True) -> \P -> \x1 x2 |-> collUnit P