--#include "IsTrue.agda"
--#include "Relation.agda"
--#include "PropRelation.agda"

HasDecEq :: (X::Set) -> Type
HasDecEq X = sig 
     eq :: rel X
     isEq :: EqualityRel (rel2Rel eq)


decEq (X::Set) :: HasDecEq X -> X -> X -> Set
decEq eqX = rel2Rel (eqX.eq)



reflDecEq (X::Set) :: (eqX :: HasDecEq X)  -> Reflexive (decEq eqX)
reflDecEq eqX = eqX.isEq.isRefl


symmDecEq (X::Set) :: (eqX :: HasDecEq X)  -> Symmetrical (decEq eqX)
symmDecEq eqX = (equalityRelEquiv (decEq eqX) eqX.isEq).isSymm 


transDecEq (X::Set) :: (eqX :: HasDecEq X)  -> Transitive (decEq eqX)
transDecEq eqX = (equalityRelEquiv (decEq eqX) eqX.isEq).isTrans


substDecEq (X::Set) :: (eqX :: HasDecEq X)  -> Substitutive (decEq eqX)
substDecEq eqX = eqX.isEq.isSubst 


decEq2Id (X::Set) 
         (eqX :: HasDecEq X)  
         (x1,x2::X) 
      :: decEq eqX x1 x2 ->
         x1 == x2
decEq2Id eql = equalityRelId (decEq eqX) eqX.isEq x1 x2 eql

id2DecEq (X::Set) 
         (eqX :: HasDecEq X)  
         (x1,x2::X) 
      :: x1 == x2 -> 
         decEq eqX x1 x2 
id2DecEq eql = idReflRel (decEq eqX) x1 x2 (reflDecEq eqX) eql

