--#include "Prelude.agda"
--#include "Relation.agda"


substId (X::Set) ::  Substitutive (==)
substId  = \(C::X -> Set) ->
             whenId (\x1 x2 -> (C x1 -> C x2)) (\x -> id)

symId (X::Set) ::  Symmetrical (==)
symId  = whenId (\(x1,x2::X) -> x2 == x1) refId

cmpId (X::Set) ::  Compositional (==)
cmpId  = let lem :: 
                 (x,y::X) |-> (x == y -> (z::X) |-> (z == x -> z == y))
             lem  = whenId (\(x,y::_) -> ((z::X) |-> (z == x -> z == y))) 
                     (\x -> \z |-> id)
         in  \(x1,x2,x3::_) |-> \(u:: x2 == x3) -> \(v::x1 == x2) -> lem u v
  
tranId (X::Set) ::  Transitive (==)
tranId  = \(x1,x2,x3::X) |->
            \(u::x1 == x2) ->
            \(v::x2 == x3) ->
            cmpId v u

equivRelId (X::Set) :: EquivRel |X (==) 
equivRelId = struct 
               isRefl ::Reflexive (==)
                 = refId
               isSymm ::Symmetrical (==)
                 = symId |X
               isTrans ::Transitive (==)
                 = tranId |X

equalityRel(X::Set) :: EqualityRel |X (==)
equalityRel = struct 
                isRefl ::Reflexive (==)
                  = refId
                isSubst ::Substitutive (==)
                  = substId


