--#include "../Integer/Integer.agda"

open IntegerOps use (+), (===)

data Types = TInteger | TBool | TTimes (a,b::Types)

idata Term :: Types -> Set  where
        Lit (i::Integer) :: Term TInteger
        Succ (t::Term TInteger) :: Term TInteger
        IsZero (t::Term TInteger) :: Term TBool
        If (|a::Types)(b:: Term TBool)(t1,t2::Term a) :: Term a
        Pair (|a,|b::Types)(l::Term a)(r::Term b) :: Term (TTimes a  b)

elimTerm :: (C :: (a :: Types) -> Term a -> Set) -> 
            (c_lit :: (i::Integer) -> C TInteger (Lit i)) -> 
            (c_succ :: (t :: Term TInteger) -> C TInteger (Succ t)) -> 
            (c_isZero :: (t::Term TInteger) -> C TBool (IsZero t)) ->
            (c_if :: (a::Types) |-> (b:: Term TBool) -> 
                     (t1,t2::Term a)  -> C a (If b t1 t2)) ->
            (c_pair :: (a,b::Types) |-> (l::Term a) -> (r::Term b) ->
             C (TTimes a  b) (Pair l r)) -> 
            (a :: Types) -> 
            (t :: Term a) -> C a t
elimTerm C c_lit c_succ c_isZero c_if c_pair a t = 
     case t of 
         (Lit i) -> c_lit i
         (Succ t') -> c_succ t'
         (IsZero t') -> c_isZero t'
         (If a' b t1 t2) -> c_if b t1 t2
         (Pair a' b l r) -> c_pair l r

typeOf :: Types -> Set
typeOf t = case t of 
               (TInteger) -> Integer
               (TBool) -> Bool
               (TTimes a b) -> typeOf a  typeOf b   

eval (a::Types) :: Term a -> typeOf a
eval t = elimTerm (\a t -> typeOf a) 
                  id 
                  (((+) 1)  eval ) 
                  ((===) 0  eval) 
                  (\a' |-> \b t1 t2 -> if eval b then eval t1 else eval t2 ) 
                  (\a' b' |-> \t1 t2 -> (eval t1, eval t2)) 
                  a 
                  t

