-- Thanks to Ana Bove for these exercises

data Bottom =
data Truth = tt

bottom_elim :: (A::Set) -> (b::Bottom) -> A
bottom_elim = \(A::Set)-> \(b::Bottom)-> case b of { } 
 

data (\/) (A,B::Set) = inl (a::A) | inr (b::B)


{- 
We could define implication:
(==>) :: Set -> Set -> Set
A ==> B = A -> B

But we use the instead A -> B directly
-}


-- Implication elimination
apply (A,B::Set) :: (A -> B) -> A -> B
apply f a = f a


Not :: (A::Set) -> Set 
Not A = A -> Bottom

{- 
We could define
 
Forall (A::Set) (B::A -> Set) :: Set
    = (a::A)-> B a 
but we choose to use the notation (a::A) -> B a 
-}



data Exists (A::Set) (B::A -> Set)
    = exists (a::A) (b::B a)
 

witness (A::Set) (B::A -> Set) :: Exists A B ->  A
witness p = case p of (exists a b)-> a
 

proof (A::Set) (B::A -> Set) :: (p::Exists A B) ->  B (witness p)
proof p = case p of (exists a b)-> b
 

{-
Exercise: Define the elimination rule for (\/)

Exercise: Define (/\) :: Set -> Set -> Set 
as a data type 
and the elimination rules for (/\)

Now add: 

(<==>) :: (A,B::Set) -> Set
A <==> B = (A -> B) /\ (B -> A)
 

Exercises: Do some of the proofs below:

-- ForAll elimination

app (A::Set) (B::A -> Set) :: (f :: (a::A) -> B a) -> (a ::A) -> B a
app f a = ?


taut1 (A::Set) :: A ->  Not(Not A)
taut1 = ?


taut2 (A::Set) :: Not A -> Not(Not(Not A))
taut2 = ?


taut3 (A::Set) :: Not(Not(Not A)) -> Not A
taut3 = ?

  
taut4 (A,B::Set) :: Not(A \/ B) -> Not A /\ Not B
taut4 = ?


taut5 (A,B::Set) :: Not A /\ Not B -> Not(A \/ B)
taut5 = ?


  
taut6 (A,B::Set) :: Not(A /\ B) ->  A -> Not B
taut6  = ?


taut7 (A,B::Set) :: (A -> Not B) -> B -> Not A
taut7  = ?


taut8 (A,B::Set) :: (B -> Not A) -> Not (A /\ B)
taut8  = ?


taut9 (A,B::Set) :: Not(Not(A->B)) -> Not(Not A) -> Not(Not B)
taut9  = ?


taut10 (A,B::Set) :: (Not(Not A) -> Not(Not B))-> A -> Not(Not B)
taut10 =  ?


taut11 (A,B::Set) :: Not (A \/ B) -> A -> Not B
taut11  = ?


taut12 (A,B::Set) :: Not(A -> B) -> Not(Not A \/ B)
taut12  = ?


taut13 (A,B::Set) :: Not(Not A \/ B) -> Not(A -> B)
taut13  = ?


taut14 (A,B::Set) :: (A -> Not(Not B)) -> Not(Not(Not A \/ B))
taut14 = ?


taut15 (A,B::Set) :: (A -> B) -> Not B -> Not A
taut15 = ?


taut16 (A,B::Set) :: Not A \/ B -> A -> B
taut16  = ?


taut17 (A,B::Set) :: Not(Not(Not A \/ B)) -> Not(Not(A -> B))
taut17 = ? 



-- Classical logic
postulate em :: (A::Set) |-> A \/ Not A

ctaut1 (A::Set) :: Not(Not A) -> A
ctaut1  = ?


ctaut2 (A,B::Set) :: (A -> B) -> Not A \/ B
ctaut2 = ?
 

-- Predicate Logic

ptaut1 (A::Set)(P::A -> Set) :: ((a::A) -> Not (P a)) -> Not (Exists A (\(a::A)-> P a))
ptaut1  = ?

ptaut2 (A::Set)(P::A -> Set) :: Not (Exists A (\(a::A)-> P a)) -> (a::A) -> Not(P a)
ptaut2 = ?


ptaut3  (A::Set)(P::A -> Set) :: Not(Not((a::A) -> P a)) -> (a'::A) -> Not(Not(P a'))
ptaut3 = ?


ptaut4  (A::Set)(P::A -> Set) :: Not(Not(Exists A (\(a'::A)-> P a'))) 
                           -> Not((a::A) -> Not(P a))
ptaut4  = ?


ptaut5  (A::Set)(P::A -> Set) :: Not((a::A) -> Not(P a))
                           -> Not(Not(Exists A (\(a'::A)-> P a')))
ptaut5  = ?


ptaut6  (A::Set)(P,Q::A -> Set) :: ((a::A)-> P a /\ (Q a))
                              <==> (((a::A)-> P a) /\ 
                                    ((a::A)-> Q a))
ptaut6 = ?

ptaut7  (A::Set)(P,Q::A -> Set) :: (((a::A)-> P a) \/ 
                                     ((a::A)-> Q a))
                              -> (a::A)-> P a \/ (Q a)
ptaut7 = ?

ptaut9  (A::Set)(P::Set)(Q::A -> Set) ::  P /\ Exists A (\(a::A)-> Q a) <==> Exists A (\(a::A)-> P /\ Q a)
ptaut9  = ?

ptaut10  (A::Set)(P::Set)(Q::A -> Set) :: (c::A) ->          -- A not empty
                                     P \/ Exists A (\(a::A)-> Q a)
                                     <==> Exists A (\(a::A)-> P \/ Q a)
ptaut10  c = ?


ptaut11  (A::Set)(P::Set)(Q::A -> Set) :: P \/ ((a::A)-> Q a)
                                     -> ((a::A)-> P \/ Q a)
ptaut11  = ?

  

cptaut1 (A::Set)(P::Set)(Q::A -> Set) :: ((a::A)-> P \/ Q a)
                                             -> P \/ ((a::A)-> Q a)
cptaut1 = ?

-}