data Bottom =
data Truth = tt

bottom_elim :: (A::Set) -> (b::Bottom) -> A
bottom_elim = \(A::Set)-> \(b::Bottom)-> case b of { } 
 

data (/\) (A,B::Set) = and (a::A) (b::B)


andElimL (A,B::Set) :: A /\ B -> A
andElimL = \(p::A /\ B)-> case p of (and a b)-> a

andElimR (A,B::Set) :: A /\ B -> B
andElimR = \(p::A /\ B)-> case p of (and a b)-> b


data (\/) (A,B::Set) = inl (a::A) | inr (b::B)



{- 
We could define implication:
(==>) :: Set -> Set -> Set
A ==> B = A -> B

But we use the instead A -> B directly
-}


-- Implication elimination
apply (A,B::Set) :: (A -> B) -> A -> B
apply f a = f a


(<==>) :: (A,B::Set) -> Set
A <==> B = (A -> B) /\ (B -> A)
 

Not :: (A::Set) -> Set 
Not A = A -> Bottom


{- 
We could define
 
Forall (A::Set) (B::A -> Set) :: Set
    = (a::A)-> B a 
but we choose to use the notation (a::A) -> B a 
-}

-- For all elimination

app (A::Set) (B::A -> Set) :: (f :: (a::A) -> B a) -> (a ::A) -> B a
app f a = f a

data Exists (A::Set) (B::A -> Set)
    = exists (a::A) (b::B a)
 

witness (A::Set) (B::A -> Set) :: Exists A B ->  A
witness p = case p of (exists a b)-> a
 

proof (A::Set) (B::A -> Set) :: (p::Exists A B) ->  B (witness p)
proof p = case p of (exists a b)-> b
 


taut1 (A::Set) :: A ->  Not(Not A)
taut1 = \(a::A)-> \(na::Not A)-> na a 


taut2 (A::Set) :: Not A -> Not(Not(Not A))
taut2 = \(na::A -> Bottom) -> \(nna::Not (Not A))-> nna na


taut3 (A::Set) :: Not(Not(Not A)) -> Not A
taut3 = \(nnna::Not (Not (Not A)))-> \(a::A)-> nnna (\(na::Not A)-> na a) 

  
taut4 (A,B::Set) :: Not(A \/ B) -> Not A /\ Not B
taut4 = \(p::Not (A \/ B))-> and (\(a::A)-> p (inl a)) (\(b::B)-> p (inr b)) 


taut5 (A,B::Set) :: Not A /\ Not B -> Not(A \/ B)
taut5 = \(p::Not A /\ Not B)-> \(q::A \/ B)->
      case p of 
        (and na nb)->
          case q of 
            (inl a)-> na a
            (inr b)-> nb b


  
taut6 (A,B::Set) :: Not(A /\ B) ->  A -> Not B
taut6  = \(p::Not (A /\ B))-> \(a::A)-> \(b::B)-> p (and a b)


taut7 (A,B::Set) :: (A -> Not B) -> B -> Not A
taut7  = \(p::A -> Not B)-> \(b::B)-> \(a::A)-> p a b


taut8 (A,B::Set) :: (B -> Not A) -> Not (A /\ B)
taut8  = \(q::B -> Not A)-> \(p::A /\ B)-> 
          case p of (and a b)-> q b a 


taut9 (A,B::Set) :: Not(Not(A->B)) -> Not(Not A) -> Not(Not B)
taut9  = \(p::Not(Not(A->B)))-> \(nna::Not(Not A))-> \(nb::Not B)->
        nna (\(a::A)-> p (\(t::A -> B)-> nb (t a))) 


taut10 (A,B::Set) :: (Not(Not A) -> Not(Not B))-> A -> Not(Not B)
taut10 =  \(p::Not(Not A) -> Not(Not B))-> \(a::A)-> \(nb::Not B)-> 
        p (\(na::Not A)-> na a) (\(b::B)-> nb b) 


taut11 (A,B::Set) :: Not (A \/ B) -> A -> Not B
taut11  = \(p::Not(A \/ B))->  \(a::A)->  \(b::B)-> p (inl a) 


taut12 (A,B::Set) :: Not(A -> B) -> Not(Not A \/ B)
taut12  = \(q::Not (A -> B))-> \(p::Not A \/ B)-> 
        case p of
          (inl na)-> q (\(a::A)-> bottom_elim B (na a))
          (inr b)-> q (\(a::A)-> b) 


taut13 (A,B::Set) :: Not(Not A \/ B) -> Not(A -> B)
taut13  = \(p::Not(Not A \/ B))-> \(q::A -> B)-> p (inl (\(r::A)-> p (inr (q r))))


taut14 (A,B::Set) :: (A -> Not(Not B)) -> Not(Not(Not A \/ B))
taut14 = \(p::A -> Not(Not B))-> \(q::Not(Not A \/ B))->
        q (inl (\(r::A)-> p r (\(s::B)-> q (inr s)))) 


taut15 (A,B::Set) :: (A -> B) -> Not B -> Not A
taut15 = \(p::A -> B)-> \(nb::Not B)-> \(a::A)-> nb (p a) 


taut16 (A,B::Set) :: Not A \/ B -> A -> B
taut16  = \(p::Not A \/ B)-> \(a::A)-> 
        case p of 
          (inl na)-> bottom_elim B (na a)
          (inr b)-> b


taut17 (A,B::Set) :: Not(Not(Not A \/ B)) -> Not(Not(A -> B))
taut17 = \(p::Not (Not (Not A \/ B)))-> \(q::Not (A -> B))-> p (taut12 q)
 



-- Classical logic
postulate em :: (A::Set) |-> A \/ Not A

ctaut1 (A::Set) :: Not(Not A) -> A
ctaut1  = \(nna::Not (Not A))-> 
       let aux ::A \/ Not A -> A
             = \(p::A \/ Not A)-> 
                case p of
                  (inl a)-> a
                  (inr na)-> bottom_elim A (nna na)
       in aux em 


ctaut2 (A,B::Set) :: (A -> B) -> Not A \/ B
ctaut2 = \(p::A -> B)-> 
       let aux ::A \/ Not A -> Not A \/ B
             = \(q::A \/ Not A)-> 
                case q of 
                  (inl a)-> inr (p a)
                  (inr na)-> inl (\(a'::A)-> na a')
       in aux em 
 

-- Predicate Logic

ptaut1 (A::Set)(P::A -> Set) :: ((a::A) -> Not (P a)) -> Not (Exists A (\(a::A)-> P a))
ptaut1  = \(p::(a::A) -> Not (P a)) -> \(q::Exists A (\(a::A)-> P a))-> 
        p (witness q) (proof q) 


ptaut2 (A::Set)(P::A -> Set) :: Not (Exists A (\(a::A)-> P a)) -> (a::A) -> Not(P a)
ptaut2 = \(q::Not (Exists A (\(a::A)-> P a)))-> \(a::A)-> \(p::P a)-> 
        q (exists a p) 


ptaut3  (A::Set)(P::A -> Set) :: Not(Not((a::A) -> P a)) -> (a'::A) -> Not(Not(P a'))
ptaut3 = \(h::Not (Not ((a::A)-> P a))) ->
      \(a'::A)-> \(np::Not (P a'))-> 
        h (\(p::(a::A)-> P a)-> np (p a')) 


ptaut4  (A::Set)(P::A -> Set) :: Not(Not(Exists A (\(a'::A)-> P a'))) 
                           -> Not((a::A) -> Not(P a))
ptaut4  = \(q::Not (Not (Exists A (\(a'::A)-> P a'))))-> 
      \(p::(a::A)-> Not (P a))-> 
        q (\(h::Exists A ( \(a'::A)-> P a'))-> p (witness h) (proof h)) 


ptaut5  (A::Set)(P::A -> Set) :: Not((a::A) -> Not(P a))
                           -> Not(Not(Exists A (\(a'::A)-> P a')))
ptaut5  = \(p::Not ((a::A)-> Not (P a))) -> 
      \(q::Not (Exists A (\(a'::A)-> P a')))-> 
        p (\(a::A)-> \(r::P a)-> q (exists a r)) 


ptaut6  (A::Set)(P,Q::A -> Set) :: ((a::A)-> P a /\ (Q a))
                              <==> (((a::A)-> P a) /\ 
                                    ((a::A)-> Q a))
ptaut6 = and (\(h::(a::A) -> P a /\ (Q a)) -> 
              and (\(a::A) -> andElimL (h a)) (\(a::A) -> andElimR (h a ))) 
             (\(h::((a::A) -> P a) /\ ((a::A) -> Q a)) -> \(a::A) -> and (andElimL h a) (andElimR h a ))

ptaut7  (A::Set)(P,Q::A -> Set) :: (((a::A)-> P a) \/ 
                                     ((a::A)-> Q a))
                              -> (a::A)-> P a \/ (Q a)
ptaut7 = \(h::((a::A) -> P a) \/ ((a::A) -> Q a)) -> \(a::A) -> case h of 
                                                                    (inl a') -> inl (a' a)
                                                                    (inr b) -> inr (b a)

ptaut9  (A::Set)(P::Set)(Q::A -> Set) ::  P /\ Exists A (\(a::A)-> Q a) <==> Exists A (\(a::A)-> P /\ Q a)
ptaut9  = and (\(h::P /\ (Exists A (\(a::A)-> Q a)))-> 
            exists (witness (andElimR h)) (and (andElimL h) (proof (andElimR h))))
          (\(h::Exists A (\(a::A)-> P /\ (Q a)))-> 
            and (andElimL (proof h)) (exists (witness h) (andElimR (proof h)))) 

ptaut10  (A::Set)(P::Set)(Q::A -> Set) :: (c::A) ->          -- A not empty
                                     P \/ Exists A (\(a::A)-> Q a)
                                     <==> Exists A (\(a::A)-> P \/ Q a)
ptaut10  c = and (\(h::P \/ (Exists A (\(a::A)-> Q a)))-> 
            let aux10 :: P \/ (Exists A (\(a::A)-> Q a)) -> 
                         Exists A (\(a::A)-> P \/ (Q a))
                  = \(h'::P \/ (Exists A ( \(a::A)-> Q a)))-> 
                      case h' of
                        (inl p)-> exists c (inl p)
                        (inr q)->
                           exists (witness q) (inr (proof q))
            in aux10 h)
          (\(h::Exists A (\(a::A)-> P \/ (Q a)))-> 
            let aux10 :: P \/ Q (witness h) -> P \/ (Exists A (\(a::A)-> Q a))
                  = \(h'::P \/ (Q (witness h)))-> 
                      case h' of
                        (inl p)-> inl p
                        (inr q)-> inr (exists (witness h) q)
            in aux10 (proof h))


ptaut11  (A::Set)(P::Set)(Q::A -> Set) :: P \/ ((a::A)-> Q a)
                                     -> ((a::A)-> P \/ Q a)
ptaut11  = \(h::P \/ ((a::A) -> Q a))-> \(a::A)-> 
        case h of 
          (inl p)-> inl p
          (inr q)-> inr (q a)

  

cptaut1 (A::Set)(P::Set)(|Q::A -> Set) :: ((a::A)-> P \/ Q a)
                                             -> P \/ ((a::A)-> Q a)
cptaut1 = \(h::((a::A)-> P \/ (Q a)))-> 
       let aux :: P \/ (Not P) -> P \/ ((a::A) -> Q a) 
             = \(emp::P \/ Not P)-> 
                case emp of
                  (inl p)-> inl p
                  (inr np)-> let aux' :: (a::A)-> Q a
                                   = \(a::A)-> 
                                      let aux'' :: P \/ Q a ->  Q a
                                            = \(h'::P \/ Q a)-> 
                                               case h' of
                                                 (inl p')-> bottom_elim (Q a) 
                                                                        (np p')
                                                 (inr qa)-> qa
                                      in aux'' (h a)
                             in inr aux'
       in aux em

