--#include "Prelude.agda" 
--#include "Bool.agda"
--#include "AlgLaw.agda" 
--#include "Integer.agda"
package IntegerProps where
 
  open IntegerOps use (+), (*), (-), negate, (<) , (>), (===), (<=), (>=)


  postulate isAssocPlus :: Ass (==) (+)
  postulate isAssocTimes :: Ass (==) (*)

  
  postulate isComPlus :: Com (==) (+)
  postulate isComTimes :: Com (==) (*)

  postulate zeroIdLft :: IdLft (==) (+) 0
  postulate zeroIdRgt :: IdRgt (==) (+) 0
  postulate zeroIdRgtM :: IdRgt (==) (-) 0
  


  postulate oneIdLft :: IdLft (==) (*) 1
  postulate oneIdRgt :: IdRgt (==) (*) 1

  
  postulate distrLTimesPlus :: DistrLft (==) (*) (+)
  postulate distrRTimesPlus :: DistrRgt (==) (*) (+)
  
  postulate distrLTimesMinus :: DistrLft (==) (*) (-)
  postulate distrRTimesMinus :: DistrRgt (==) (*) (-)

  postulate homNegatePlus :: HomBinop (==) negate (+) (+)
  postulate homNegateTimes :: HomBinop (==) negate (*) (*)
  postulate homNegateMinus :: HomBinop (==) negate (-) (-)

  postulate  cnstLZero :: CnstLft (==) (*) 0
  postulate  cnstRZero :: CnstRgt (==) (*) 0

  postulate invLftNegate :: InvLft (==) (+) 0 negate
  postulate invRgtNegate :: InvRgt (==) (+) 0 negate

  postulate invLftNegateM :: InvLft (==) (-) 0 negate
  postulate invRgtNegateM :: InvRgt (==)  (-) 0 negate
  
  postulate isEqIntegerL :: (i1,i2::Integer) -> 
             IsTrue (i1 === i2) -> i1 == i2
  postulate isEqIntegerR :: (i1,i2::Integer) -> 
             i1 == i2 -> IsTrue (i1 === i2) 


