--#include "Prelude.agda"
--#include "Bool.agda"

idata  IsTrue :: Bool -> Set where
           isTrue :: IsTrue True
  
elimIsTrue :: (C :: (b::Bool) -> IsTrue b -> Set) ->
              (C True isTrue) ->
              (b :: Bool) -> 
              (h::IsTrue b) -> 
              C b h
elimIsTrue C c b h = case h of 
                         (isTrue) -> c

  

IsFalse :: Bool -> Set
IsFalse b = Not (IsTrue b)

isFalse :: IsFalse False
isFalse = elimIsTrue (\(b::Bool) -> \(h::IsTrue b) -> liftBool b) unit False


elimIsTrue' :: (C :: (b::Bool) -> IsTrue b -> Set) ->
              (b :: Bool) -> 
              (h::IsTrue b) -> 
              C b h -> C True isTrue
elimIsTrue' C b h =  case h of 
                           (isTrue) -> id

elimBool' ::  (P :: Bool -> Set) ->
              (b :: Bool) -> 
              (c_f :: IsFalse b -> P b) ->
              (c_f :: IsTrue b -> P b) ->
              P b
elimBool' P b c_f c_t = case b of 
                            (False) -> c_f isFalse
                            (True) -> c_t isTrue

elimBool2 ::  (P :: Bool -> Set) ->
              (b :: Bool) -> 
              (c_f :: IsFalse b -> P False) ->
              (c_f :: IsTrue b -> P True) ->
              P b
elimBool2 P b c_f c_t = case b of 
                            (False) -> c_f isFalse
                            (True) -> c_t isTrue



elimIsTrueS(X::Set) :: 
              (C :: (h::Bool) -> IsTrue h -> Set) ->
              (b :: Bool) -> 
              (t1,t2::IsTrue b) -> 
              C b t1 -> C b t2
elimIsTrueS C b t1 t2 h = case t2 of 
                              (isTrue) -> elimIsTrue' C True t1 h

ifTac (X::Set) ::
      (x,y::X) -> 
      (b :: Bool) -> 
      (C:: X -> Set) -> 
      (c_t :: IsTrue b -> C x) -> 
      (c_f :: IsFalse b -> C y) -> 
     C (if b then x else y) 
ifTac x y b C c_t c_f = 
    case b of 
           (False) -> c_f isFalse
           (True) -> c_t isTrue

liftIsTrue :: (b::Bool) -> liftBool b -> IsTrue b
liftIsTrue b h = case b of 
                     (False) -> elimEmpty (\(h'::Empty) -> IsTrue b) h
                     (True) -> isTrue

isTrueLift :: (b::Bool) -> IsTrue b -> liftBool b 
isTrueLift b h = case h of 
                     (isTrue) -> unit


decIsTrue :: (p::Bool) -> Decidable (IsTrue p)
decIsTrue p = elimBool (\p' -> Decidable (IsTrue p')) 
                       (Inl isTrue) 
                       (Inr isFalse) 
                       p

existT ::  (p::Bool) -> (q::IsTrue p -> Bool) -> Bool
existT p q = case p of 
             (True) -> q isTrue
             (False) -> False
  
forallT ::  (p::Bool) -> (q::IsTrue p -> Bool) -> Bool
forallT p q = case p of 
              (True) -> q isTrue
              (False) -> p


pred2Pred (X::Set) :: pred X -> Pred X
pred2Pred p = \(x::X) -> IsTrue (p x)


rel2Rel (X::Set) :: rel X -> Rel X
rel2Rel r  = \(x,y::X) -> IsTrue (x `r` y)
  

dec2Bool :: (X::Set) -> 
            (decP::Decidable X) -> 
            Sigma (\(b::Bool) -> (IsTrue b -> X)(X -> IsTrue b))
dec2Bool X decP  = whenPlus 
      (\(h::X) -> dep_pair True (const h, const isTrue))
      (\(h::Not X) -> dep_pair False (\abs -> absurdElim abs isFalse X, 
                                      \x -> absurdElim x h (IsTrue False)))
      decP


notLem1 (b::Bool) :: IsTrue b -> IsFalse (not b)
notLem1 h = case h of 
                (isTrue) -> isFalse

notLem2 (b::Bool) :: IsFalse (not b) -> IsTrue b
notLem2 h = case b of 
            (True) -> isTrue 
            (False) -> absurdElim isTrue h (IsTrue False) 


orLem11 (b1,b2::Bool) :: IsTrue b1 -> IsTrue (b1 || b2) 
orLem11 h  = case h of 
               (isTrue) -> isTrue 

orLem12 (b1,b2::Bool) :: IsTrue b2 -> IsTrue (b1 || b2) 
orLem12 h  = elimBool (\(b1'::Bool) -> IsTrue (b1' || b2)) isTrue h b1


orLem2 (b1,b2::Bool) :: IsTrue (b1 || b2) -> Plus (IsTrue b1) (IsTrue b2)  
orLem2 h = case b1 of 
           (True) -> Inl isTrue
           (False) -> Inr h



andLem1 (b1,b2::Bool) :: IsTrue b1 -> IsTrue b2 -> IsTrue (b1 && b2) 
andLem1 h1 h2  = elimIsTrue (\b1' h -> IsTrue (b1' && b2))  h2 b1 h1

andLem21(b1,b2::Bool) :: IsTrue (b1 && b2) -> IsTrue b1 
andLem21 h = case b1 of 
             (True) -> isTrue
             (False) -> h

andLem22(b1,b2::Bool) :: IsTrue (b1 && b2) -> IsTrue b2
andLem22 h = case b1 of 
             (True) -> h
             (False) -> absurdElim h isFalse (IsTrue b2)

