---------------------------------------------------------------------------
-- The Maybe set ----------------------------------------------------------
---------------------------------------------------------------------------

data Maybe (X::Set) = Nothing | Just (a::X)

elimMaybe(X::Set) :: (C :: Maybe X -> Set) -> 
                        C Nothing -> 
                       ((a::X) -> C (Just a)) ->
                       (m::Maybe X) -> 
                       C m
elimMaybe C c_n c_j m = 
      case m of
          (Nothing) -> c_n
          (Just a)  -> c_j a

whenMaybe (X,Y::Set) :: 
            Y -> (X -> Y) -> Maybe X -> Y
whenMaybe c_n c_j m = 
      case m of
          (Nothing) -> c_n
          (Just a)  -> c_j a

mapMaybe (X,Y::Set) :: (X -> Y) -> Maybe X -> Maybe Y
mapMaybe f m = 
      case m of
          (Nothing) -> Nothing
          (Just x)  -> Just (f x)
