--#include "Prelude.agda"

---------------------------------------------------------------------------
-- Natural numbers. -------------------------------------------------------
---------------------------------------------------------------------------

data Nat   :: Set  = zero | succ (m::Nat)

elimNat :: 
    (C::Nat -> Set) ->
    (c_z::C zero) ->
    (c_s::(x::Nat) -> C x -> C (succ x)) ->
    (m::Nat) ->
    C m
elimNat C c_z c_s m = 
              case m of 
                  (zero) -> c_z
                  (succ m') -> c_s m' (elimNat C c_z c_s m')

whenNat (X::Set) :: 
        (c_z::X) ->
        (c_s:: Nat -> X -> X) ->
        (m::Nat) ->
        X
whenNat c_z c_s m= 
              case m of 
                  (zero) -> c_z
                  (succ m') -> c_s m' (whenNat c_z c_s m')



predecessor ::  (x::Nat) -> Nat
predecessor x = case x of 
               (zero) -> zero
               (succ x') -> x'

(+) ::  (m,n::Nat) -> Nat
(+) m n = case m of 
                (zero) -> n
                (succ m') -> succ (m' + n)
(*) ::  (m,n::Nat) -> Nat
(*) m n = case m of 
                (zero) -> zero
                (succ m') -> n + m' * n
(^) ::  (m,n::Nat) -> Nat
(^) m n = case n of 
                (zero) -> succ (zero)
                (succ n') -> m * m ^ n'

-- Comparision operations.
(===) ::  (m,n::Nat) -> Bool
(===) m n = case m of 
                 (zero) ->
                   case n of 
                       (zero) -> True
                       (succ n') -> False
                 (succ m') ->
                   case n of 
                       (zero) -> False
                       (succ n') -> m' === n'

(<=) ::  (m,n::Nat) -> Bool
(<=) m n = case m of 
                 (zero) -> True
                 (succ m') ->
                   case n of 
                       (zero) -> False
                       (succ n') -> m' <= n'

(<) ::  (m,n::Nat) -> Bool
(<) m n = succ m <= n


(>=) ::  (m,n::Nat) -> Bool
(>=) m n = n <= m

(>) ::  (m,n::Nat) -> Bool
(>) m n = n < m


max ::  (m,n::Nat) -> Nat
max m n = if m > n then m else n

min ::  (m,n::Nat) -> Nat
min m n = if m < n then m else n


monus ::  (m,n::Nat) -> Nat
monus m n = case n of 
                  (zero) -> m
                  (succ n') ->
                    case m of 
                        (zero) -> zero
                        (succ m') -> monus m' n'

absdiff ::  (m,n::Nat) -> Nat
absdiff m n = case m of 
                    (zero) -> n
                    (succ m') ->
                      case n of 
                          (zero) -> m
                          (succ n') -> absdiff m' n'
  
